=== demos/jni/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Zellman 2009

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_c')
	opt.load('java')

def configure(conf):
	conf.load('compiler_c')
	conf.load('java')

	conf.check_jni_headers()

def build(bld):
	bld(features='javac jar', srcdir='src/java', outdir='src/java', basedir='src/java', destfile='stringUtils.jar')

	bld.shlib(
		source   = 'src/jni/source/StringUtils.c',
		includes = 'src/jni/include',
		target   = 'stringUtils',
		uselib   = 'JAVA')
